#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>

void USART0_init()
{
	//Setez baund rate la 38400
	UBRR0H = 0;
	UBRR0L = 103;

	//Pornesc transmitatorul
	UCSR0B = (1<<RXEN0);
	UCSR0B |= (1<<RXCIE0);
}

char USART0_receive()
{
	while (!(UCSR0A & (1<<RXC0)));

	return UDR0;
}

//Seteaza pinii corespunzatori motoarelor
void initEngine()
{
	DDRB |= (1<<PB1);
	DDRB |= (1<<PB2);
	DDRB |= (1<<PB3);
	DDRB |= (1<<PB4);
	DDRD |= (1<<PD4);
	DDRD |= (1<<PD5);

	PORTB &= ~(1<<PB1);
	PORTB &= ~(1<<PB2);
	PORTB &= ~(1<<PB3);
	PORTB &= ~(1<<PB4);
	PORTD |= (1<<PD4);
	PORTD |= (1<<PD5);

}

void moveForward()
{
	PORTB &= ~(1<<PB1);
	PORTB |= (1<<PB2);

}

void moveBack()
{
	PORTB &= ~(1<<PB2);
	PORTB |= (1<<PB1);
}

void moveLeft()
{
	PORTB &= ~(1<<PB4);
	PORTB |= (1<<PB3);
}

void moveRight()
{
	PORTB &= ~(1<<PB3);
	PORTB |= (1<<PB4);
}

void stopFunc()
{
	PORTB &= ~(1<<PB1);
	PORTB &= ~(1<<PB2);
	PORTB &= ~(1<<PB3);
	PORTB &= ~(1<<PB4);
}

int main()
{
	USART0_init();
	initEngine();

	char rt;

	while (1) {
		rt = USART0_receive();
		switch(rt) {
			case 'F':
				moveForward();
				break;
			case 'B':
				moveBack();
				break;
			case 'L':
				moveLeft();
				break;
			case 'R':
				moveRight();
				break;
			case 'G':
				moveForward();
				moveLeft();
				break;
			case 'I':
				moveForward();
				moveRight();
				break;
			case 'H':
				moveBack();
				moveLeft();
				break;
			case 'J':
				moveBack();
				moveRight();
				break;
			default:
				stopFunc();
				break;
		}
		
	}
}